<?php
/**
 * @file
 *   AJAX block provider for Taskbar.
 */

function taskbar_provider_ajaxblock_definition() {
  return array(
    'name' => 'ajaxblock',
    'title' => 'Ajax Blocks',
    'ajax' => TRUE,
    'realtime' => FALSE,
    'callback' => 'taskbar_provider_ajaxblock',
    'settings form' => 'taskbar_provider_ajaxblock_settings',
    'settings form submit' => 'taskbar_provider_ajaxblock_settings_submit',
    'file' => 'taskbar_provider.ajaxblock.inc',
    'path' => drupal_get_path('module', 'taskbar') . '/providers',
  );
}

function taskbar_provider_ajaxblock($item, $action = 'status') {
  if ($action == 'status') {
    return array('content' => $item->settings['text']);
  }
  else {
    $block = module_invoke($item->settings['module'], 'block', 'view', $item->settings['delta']);
    return array('extra' => $block['content']);
  }
}

/**
 * Settings form for the ajaxblock provider.
 */
function taskbar_provider_ajaxblock_settings(&$form, &$form_state, $item) {
  taskbar_provider_get_function('block', 'callback');
  taskbar_provider_block_settings($form, $form_state, $item);
}

function taskbar_provider_ajaxblock_settings_submit($form, &$form_state, &$item) {
  taskbar_provider_get_function('block', 'callback');
  taskbar_provider_block_settings_submit($form, $form_state, $item);
}