/**
 * @file
 *   Taskbar JavaScript tools
 */
(function ($) {
Drupal.taskbar = Drupal.taskbar || {};
Drupal.settings.taskbar = Drupal.settings.taskbar || {};

Drupal.behaviors.taskbar = function (context) {
  if (context == document) {
    $('body').addClass('with-taskbar');
    if (Drupal.settings.taskbar.auto_refresh) {
      setInterval('Drupal.taskbar.refresh()', Drupal.settings.taskbar.delay);
    }
  }

  $('.taskbar-item').each(function() {
    var T = $(this);
    if (T.hasClass('taskbar-item-options-ajax')) {
      if (T.find('.taskbar-item-extra').length == 0) {
        T.append('<div class="taskbar-item-extra"></div>');
      }
      T.find('.taskbar-item-content:not(.taskbar-processed)').addClass('taskbar-processed').click(function() {
        T.toggleClass('taskbar-item-active');
        if (T.find('.taskbar-item-extra').is(':visible')) {
          T.find('.taskbar-item-extra').slideToggle('fast');
        }
        else {
          T.find('.taskbar-item-extra').html('<div class="loading"></div>');
          T.find('.taskbar-item-extra').slideToggle('fast');
          $.ajax({
            url: Drupal.settings.basePath + 'taskbar/display/' + T.attr('id').replace(/^taskbar-item-/, ''),
            dataType: 'json',
            success: Drupal.taskbar.AJAXrespond
          });
        }
      });
    }
    else if (T.find('.taskbar-item-extra').length > 0) {
      T.find('.taskbar-item-content:not(.taskbar-processed)').addClass('taskbar-processed').click(function() {
        T.toggleClass('taskbar-item-active').find('.taskbar-item-extra').slideToggle('fast');
      });
    }
  });
}

Drupal.taskbar.refresh = function() {
  $.ajax({
    url: Drupal.settings.basePath + 'taskbar/status',
    dataType: 'json',
    success: Drupal.taskbar.AJAXrespond
  });
}

// This is a subset of Ctools Ajax Responder commands
Drupal.taskbar.AJAXrespond = function(data) {
  $.each(data, function(i, item) {
    if (item.command == 'html') {
      $(item.selector).html(item.data);
    }
    else if (item.command == 'replace') {
      $(item.selector).replaceWith(item.data);
    }
    Drupal.attachBehaviors($(item.selector));
  });
}
})(jQuery);